diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/ap-wifi-mac.cc ns-3.36/src/wifi/model/ap-wifi-mac.cc
--- ns-3.35/src/wifi/model/ap-wifi-mac.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/ap-wifi-mac.cc	2022-04-30 18:23:58.202735200 -0700
@@ -1281,23 +1326,23 @@
                 {
                   NS_LOG_DEBUG ("The Basic Rate set modes are supported by the station");
                   //update all its supported modes in its associated WifiRemoteStation
-                  for (const auto & mode : m_phy->GetModeList ())
+                  for (const auto & mode : GetWifiPhy ()->GetModeList ())
                     {
-                      if (rates.IsSupportedRate (mode.GetDataRate (m_phy->GetChannelWidth ())))
+                      if (rates.IsSupportedRate (mode.GetDataRate (GetWifiPhy ()->GetChannelWidth ())))
                         {
-                          m_stationManager->AddSupportedMode (from, mode);
+                          GetWifiRemoteStationManager ()->AddSupportedMode (from, mode);
                         }
                     }
-                  if (GetErpSupported () && m_stationManager->GetErpOfdmSupported (from) && capabilities.IsShortSlotTime ())
+                  if (GetErpSupported () && GetWifiRemoteStationManager ()->GetErpOfdmSupported (from) && capabilities.IsShortSlotTime ())
                     {
-                      m_stationManager->AddSupportedErpSlotTime (from, true);
+                      GetWifiRemoteStationManager ()->AddSupportedErpSlotTime (from, true);
                     }
                   if (GetHtSupported ())
                     {
                       HtCapabilities htCapabilities = reassocReq.GetHtCapabilities ();
                       if (htCapabilities.IsSupportedMcs (0))
                         {
-                          m_stationManager->AddStationHtCapabilities (from, htCapabilities);
+                          GetWifiRemoteStationManager ()->AddStationHtCapabilities (from, htCapabilities);
                         }
                     }
                   if (GetVhtSupported ())
@@ -1306,12 +1351,12 @@
                       //we will always fill in RxHighestSupportedLgiDataRate field at TX, so this can be used to check whether it supports VHT
                       if (vhtCapabilities.GetRxHighestSupportedLgiDataRate () > 0)
                         {
-                          m_stationManager->AddStationVhtCapabilities (from, vhtCapabilities);
-                          for (const auto & mcs : m_phy->GetMcsList (WIFI_MOD_CLASS_VHT))
+                          GetWifiRemoteStationManager ()->AddStationVhtCapabilities (from, vhtCapabilities);
+                          for (const auto & mcs : GetWifiPhy ()->GetMcsList (WIFI_MOD_CLASS_VHT))
                             {
                               if (vhtCapabilities.IsSupportedTxMcs (mcs.GetMcsValue ()))
                                 {
-                                  m_stationManager->AddSupportedMcs (hdr->GetAddr2 (), mcs);
+                                  GetWifiRemoteStationManager ()->AddSupportedMcs (hdr->GetAddr2 (), mcs);
                                   //here should add a control to add basic MCS when it is implemented
                                 }
                             }
@@ -1327,18 +1372,18 @@
                       HeCapabilities heCapabilities = reassocReq.GetHeCapabilities ();
                       if (heCapabilities.GetSupportedMcsAndNss () != 0)
                         {
-                          m_stationManager->AddStationHeCapabilities (from, heCapabilities);
-                          for (const auto & mcs : m_phy->GetMcsList (WIFI_MOD_CLASS_HE))
+                          GetWifiRemoteStationManager ()->AddStationHeCapabilities (from, heCapabilities);
+                          for (const auto & mcs : GetWifiPhy ()->GetMcsList (WIFI_MOD_CLASS_HE))
                             {
                               if (heCapabilities.IsSupportedTxMcs (mcs.GetMcsValue ()))
                                 {
-                                  m_stationManager->AddSupportedMcs (hdr->GetAddr2 (), mcs);
+                                  GetWifiRemoteStationManager ()->AddSupportedMcs (hdr->GetAddr2 (), mcs);
                                   //here should add a control to add basic MCS when it is implemented
                                 }
                             }
                         }
                     }
-                  m_stationManager->RecordWaitAssocTxOk (from);
+                  GetWifiRemoteStationManager ()->RecordWaitAssocTxOk (from);
                   NS_LOG_DEBUG ("Send reassociation response with success status");
                   SendAssocResp (hdr->GetAddr2 (), true, true);
                 }
@@ -1347,18 +1392,18 @@
           else if (hdr->IsDisassociation ())
             {
               NS_LOG_DEBUG ("Disassociation received from " << from);
-              m_stationManager->RecordDisassociated (from);
+              GetWifiRemoteStationManager ()->RecordDisassociated (from);
               for (auto it = m_staList.begin (); it != m_staList.end (); ++it)
                 {
                   if (it->second == from)
                     {
                       m_staList.erase (it);
                       m_deAssocLogger (it->first, it->second);
-                      if (m_stationManager->GetDsssSupported (from) && !m_stationManager->GetErpOfdmSupported (from))
+                      if (GetWifiRemoteStationManager ()->GetDsssSupported (from) && !GetWifiRemoteStationManager ()->GetErpOfdmSupported (from))
                         {
                           m_numNonErpStations--;
                         }
-                      if (!m_stationManager->GetHtSupported (from))
+                      if (!GetWifiRemoteStationManager ()->GetHtSupported (from))
                         {
                           m_numNonHtStations--;
                         }
@@ -1375,7 +1420,7 @@
   //Invoke the receive handler of our parent class to deal with any
   //other frames. Specifically, this will handle Block Ack-related
   //Management Action frames.
-  RegularWifiMac::Receive (Create<WifiMacQueueItem> (packet, *hdr));
+  WifiMac::Receive (Create<WifiMacQueueItem> (packet, *hdr));
 }
 
 void
@@ -1420,8 +1465,8 @@
         }
     }
   NS_ABORT_IF (!TraceConnectWithoutContext ("AckedMpdu", MakeCallback (&ApWifiMac::TxOk, this)));
-  NS_ABORT_IF (!TraceConnectWithoutContext ("MpduResponseTimeout", MakeCallback (&ApWifiMac::TxFailed, this)));
-  RegularWifiMac::DoInitialize ();
+  NS_ABORT_IF (!TraceConnectWithoutContext ("DroppedMpdu", MakeCallback (&ApWifiMac::TxFailed, this)));
+  WifiMac::DoInitialize ();
   UpdateShortSlotTimeEnabled ();
   UpdateShortPreambleEnabled ();
 }
@@ -1430,7 +1475,7 @@
 ApWifiMac::GetUseNonErpProtection (void) const
 {
   bool useProtection = (m_numNonErpStations > 0) && m_enableNonErpProtection;
-  m_stationManager->SetUseNonErpProtection (useProtection);
+  GetWifiRemoteStationManager ()->SetUseNonErpProtection (useProtection);
   return useProtection;
 }
 
@@ -1458,7 +1503,7 @@
 uint16_t
 ApWifiMac::GetAssociationId (Mac48Address addr) const
 {
-  return m_stationManager->GetAssociationId (addr);
+  return GetWifiRemoteStationManager ()->GetAssociationId (addr);
 }
 
 uint8_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/ap-wifi-mac.h ns-3.36/src/wifi/model/ap-wifi-mac.h
--- ns-3.35/src/wifi/model/ap-wifi-mac.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/ap-wifi-mac.h	2022-04-30 18:23:58.202735200 -0700
@@ -23,7 +23,7 @@
 #ifndef AP_WIFI_MAC_H
 #define AP_WIFI_MAC_H
 
-#include "regular-wifi-mac.h"
+#include "wifi-mac.h"
 #include <unordered_map>
 
 namespace ns3 {
@@ -38,6 +38,7 @@
 class VhtOperation;
 class HeOperation;
 class CfParameterSet;
+class UniformRandomVariable;
 
 /**
  * \brief Wi-Fi AP state machine
@@ -46,7 +47,7 @@
  * Handle association, dis-association and authentication,
  * of STAs within an infrastructure BSS.
  */
-class ApWifiMac : public RegularWifiMac
+class ApWifiMac : public WifiMac
 {
 public:
   /**
@@ -59,6 +60,7 @@
   virtual ~ApWifiMac ();
 
   void SetLinkUpCallback (Callback<void> linkUp) override;
+  bool CanForwardPacketsTo (Mac48Address to) const override;
   void Enqueue (Ptr<Packet> packet, Mac48Address to) override;
   void Enqueue (Ptr<Packet> packet, Mac48Address to, Mac48Address from) override;
   bool SupportsSendFrom (void) const override;
@@ -162,9 +164,8 @@
    *
    * \param timeoutReason the reason why the TX timer was started (\see WifiTxTimer::Reason)
    * \param mpdu the MPDU that we failed to sent
-   * \param txVector the TX vector used to send the MPDU
    */
-  void TxFailed (uint8_t timeoutReason, Ptr<const WifiMacQueueItem> mpdu, const WifiTxVector& txVector);
+  void TxFailed (WifiMacDropReason timeoutReason, Ptr<const WifiMacQueueItem> mpdu);
 
   /**
    * This method is called to de-aggregate an A-MSDU and forward the
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/block-ack-agreement.cc ns-3.36/src/wifi/model/block-ack-agreement.cc
--- ns-3.35/src/wifi/model/block-ack-agreement.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/block-ack-agreement.cc	2022-04-30 18:23:58.202735200 -0700
@@ -137,13 +137,13 @@
 bool
 BlockAckAgreement::IsImmediateBlockAck (void) const
 {
-  return (m_blockAckPolicy == 1);
+  return m_blockAckPolicy == 1;
 }
 
 bool
 BlockAckAgreement::IsAmsduSupported (void) const
 {
-  return (m_amsduSupported == 1) ? true : false;
+  return m_amsduSupported == 1;
 }
 
 uint16_t
@@ -162,7 +162,7 @@
 bool
 BlockAckAgreement::IsHtSupported (void) const
 {
-  return (m_htSupported == 1) ? true : false;
+  return m_htSupported == 1;
 }
 
 BlockAckType
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/block-ack-manager.cc ns-3.36/src/wifi/model/block-ack-manager.cc
--- ns-3.35/src/wifi/model/block-ack-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/block-ack-manager.cc	2022-04-30 18:23:58.202735200 -0700
@@ -27,6 +27,7 @@
 #include "wifi-mac-queue.h"
 #include "qos-utils.h"
 #include "wifi-tx-vector.h"
+#include <optional>
 
 namespace ns3 {
 
@@ -184,7 +185,7 @@
   if (it != m_agreements.end ())
     {
       OriginatorBlockAckAgreement& agreement = it->second.first;
-      agreement.SetBufferSize (respHdr->GetBufferSize () + 1);
+      agreement.SetBufferSize (respHdr->GetBufferSize ());
       agreement.SetTimeout (respHdr->GetTimeout ());
       agreement.SetAmsduSupport (respHdr->IsAmsduSupported ());
       agreement.SetStartingSequence (startingSeq);
@@ -236,8 +237,8 @@
 
   // store the packet and keep the list sorted in increasing order of sequence number
   // with respect to the starting sequence number
-  PacketQueueI it = agreementIt->second.second.begin ();
-  while (it != agreementIt->second.second.end ())
+  auto it = agreementIt->second.second.rbegin ();
+  while (it != agreementIt->second.second.rend ())
     {
       if (mpdu->GetHeader ().GetSequenceControl () == (*it)->GetHeader ().GetSequenceControl ())
         {
@@ -247,15 +248,15 @@
 
       uint16_t dist = agreementIt->second.first.GetDistance ((*it)->GetHeader ().GetSequenceNumber ());
 
-      if (mpduDist < dist ||
-          (mpduDist == dist && mpdu->GetHeader ().GetFragmentNumber () < (*it)->GetHeader ().GetFragmentNumber ()))
+      if (mpduDist > dist ||
+          (mpduDist == dist && mpdu->GetHeader ().GetFragmentNumber () > (*it)->GetHeader ().GetFragmentNumber ()))
         {
           break;
         }
 
       it++;
     }
-  agreementIt->second.second.insert (it, mpdu);
+  agreementIt->second.second.insert (it.base (), mpdu);
   agreementIt->second.first.NotifyTransmittedMpdu (mpdu);
   mpdu->SetInFlight ();
 }
@@ -293,7 +294,7 @@
               continue;
             }
           if (nextBar->skipIfNoDataQueued
-              && m_queue->PeekByTidAndAddress (nextBar->tid, recipient) == m_queue->end ())
+              && m_queue->PeekByTidAndAddress (nextBar->tid, recipient) == nullptr)
             {
               // skip this BAR as there is no data queued
               nextBar++;
@@ -309,8 +310,6 @@
                   continue;
                 }
 
-              WifiMacQueue::ConstIterator queueIt = (*mpduIt)->GetQueueIterator ();
-
               if ((*mpduIt)->GetTimeStamp () + m_queue->GetMaxDelay () <= now)
                 {
                   // MPDU expired
@@ -319,7 +318,7 @@
                   // consequent call to NotifyDiscardedMpdu does nothing (in particular,
                   // does not schedule a BAR) because we have advanced the transmit window
                   // and hence this MPDU became an old packet
-                  m_queue->TtlExceeded (queueIt, now);
+                  m_queue->TtlExceeded (*mpduIt, now);
                   mpduIt = it->second.second.erase (mpduIt);
                 }
               else
@@ -391,7 +390,6 @@
     }
 
   WifiMacHeader& hdr = (*mpduIt)->GetHeader ();
-  WifiMacQueue::ConstIterator queueIt = (*mpduIt)->GetQueueIterator ();
 
   NS_ASSERT (hdr.GetAddr1 () == it->first.first);
   NS_ASSERT (hdr.IsQosData () && hdr.GetQosTid () == it->first.second);
@@ -401,21 +399,25 @@
       NS_LOG_DEBUG ("Old packet. Remove from the EDCA queue, too");
       if (!m_droppedOldMpduCallback.IsNull ())
         {
-          m_droppedOldMpduCallback (*queueIt);
+          m_droppedOldMpduCallback (*mpduIt);
         }
-      m_queue->Remove (queueIt);
+      m_queue->Remove (*mpduIt, false);
       return it->second.second.erase (mpduIt);
     }
 
-  auto nextIt = std::next (mpduIt);
+  std::optional<PacketQueueI> prevIt;
+  if (mpduIt != it->second.second.begin ())
+    {
+      prevIt = std::prev (mpduIt);
+    }
 
-  if (m_queue->TtlExceeded (queueIt, now))
+  if (m_queue->TtlExceeded (*mpduIt, now))
     {
       // WifiMacQueue::TtlExceeded() has removed the MPDU from the EDCA queue
       // and fired the Expired trace source, which called NotifyDiscardedMpdu,
-      // which removed this MPDU from the in flight queue as well
+      // which removed this MPDU (and possibly others) from the in flight queue as well
       NS_LOG_DEBUG ("MSDU lifetime expired, drop MPDU");
-      return nextIt;
+      return (prevIt.has_value () ? std::next (prevIt.value ()) : it->second.second.begin ());
     }
 
   if (status == STAY_INFLIGHT)
@@ -444,6 +446,8 @@
   AgreementsI it = m_agreements.find (std::make_pair (recipient, tid));
   NS_ASSERT (it != m_agreements.end ());
 
+  it->second.first.NotifyAckedMpdu (mpdu);
+
   // remove the acknowledged frame from the queue of outstanding packets
   for (auto queueIt = it->second.second.begin (); queueIt != it->second.second.end (); ++queueIt)
     {
@@ -453,8 +457,6 @@
           break;
         }
     }
-
-  it->second.first.NotifyAckedMpdu (mpdu);
 }
 
 void
@@ -547,7 +549,7 @@
     }
   return {nSuccessfulMpdus, nFailedMpdus};
 }
-  
+
 void
 BlockAckManager::NotifyMissedBlockAck (Mac48Address recipient, uint8_t tid)
 {
@@ -608,6 +610,7 @@
     {
       if (it->second.first.GetDistance ((*mpduIt)->GetHeader ().GetSequenceNumber ()) >= SEQNO_SPACE_HALF_SIZE)
         {
+          NS_LOG_DEBUG ("Dropping old MPDU: " << **mpduIt);
           m_queue->DequeueIfQueued (*mpduIt);
           if (!m_droppedOldMpduCallback.IsNull ())
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/channel-access-manager.cc ns-3.36/src/wifi/model/channel-access-manager.cc
--- ns-3.35/src/wifi/model/channel-access-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/channel-access-manager.cc	2022-04-30 18:23:58.202735200 -0700
@@ -660,6 +660,9 @@
       m_accessTimeout.Cancel ();
     }
 
+  // Notify the FEM, which will in turn notify the MAC
+  m_feManager->NotifySwitchingStartNow (duration);
+
   //Reset backoffs
   for (auto txop : m_txops)
     {
@@ -671,7 +674,6 @@
         }
       txop->ResetCw ();
       txop->m_access = Txop::NOT_REQUESTED;
-      txop->NotifyChannelSwitching ();
     }
 
   NS_LOG_DEBUG ("switching start for " << duration);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/ctrl-headers.cc ns-3.36/src/wifi/model/ctrl-headers.cc
--- ns-3.35/src/wifi/model/ctrl-headers.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/ctrl-headers.cc	2022-04-30 18:23:58.202735200 -0700
@@ -160,7 +160,7 @@
 void
 CtrlBAckRequestHeader::SetBarControl (uint16_t bar)
 {
-  m_barAckPolicy = ((bar & 0x01) == 1) ? true : false;
+  m_barAckPolicy = ((bar & 0x01) == 1);
   if (((bar >> 1) & 0x0f) == 0x03)
     {
       m_barType.m_variant = BlockAckReqType::MULTI_TID;
@@ -244,25 +244,25 @@
 bool
 CtrlBAckRequestHeader::IsBasic (void) const
 {
-  return (m_barType.m_variant == BlockAckReqType::BASIC) ? true : false;
+  return m_barType.m_variant == BlockAckReqType::BASIC;
 }
 
 bool
 CtrlBAckRequestHeader::IsCompressed (void) const
 {
-  return (m_barType.m_variant == BlockAckReqType::COMPRESSED) ? true : false;
+  return m_barType.m_variant == BlockAckReqType::COMPRESSED;
 }
 
 bool
 CtrlBAckRequestHeader::IsExtendedCompressed (void) const
 {
-  return (m_barType.m_variant == BlockAckReqType::EXTENDED_COMPRESSED) ? true : false;
+  return m_barType.m_variant == BlockAckReqType::EXTENDED_COMPRESSED;
 }
 
 bool
 CtrlBAckRequestHeader::IsMultiTid (void) const
 {
-  return (m_barType.m_variant == BlockAckReqType::MULTI_TID) ? true : false;
+  return m_barType.m_variant == BlockAckReqType::MULTI_TID;
 }
 
 
@@ -503,7 +503,7 @@
 bool
 CtrlBAckResponseHeader::MustSendHtImmediateAck (void) const
 {
-  return (m_baAckPolicy) ? true : false;
+  return m_baAckPolicy;
 }
 
 uint8_t
@@ -539,31 +539,31 @@
 bool
 CtrlBAckResponseHeader::IsBasic (void) const
 {
-  return (m_baType.m_variant == BlockAckType::BASIC) ? true : false;
+  return m_baType.m_variant == BlockAckType::BASIC;
 }
 
 bool
 CtrlBAckResponseHeader::IsCompressed (void) const
 {
-  return (m_baType.m_variant == BlockAckType::COMPRESSED) ? true : false;
+  return m_baType.m_variant == BlockAckType::COMPRESSED;
 }
 
 bool
 CtrlBAckResponseHeader::IsExtendedCompressed (void) const
 {
-  return (m_baType.m_variant == BlockAckType::EXTENDED_COMPRESSED) ? true : false;
+  return m_baType.m_variant == BlockAckType::EXTENDED_COMPRESSED;
 }
 
 bool
 CtrlBAckResponseHeader::IsMultiTid (void) const
 {
-  return (m_baType.m_variant == BlockAckType::MULTI_TID) ? true : false;
+  return m_baType.m_variant == BlockAckType::MULTI_TID;
 }
 
 bool
 CtrlBAckResponseHeader::IsMultiSta (void) const
 {
-  return (m_baType.m_variant == BlockAckType::MULTI_STA) ? true : false;
+  return m_baType.m_variant == BlockAckType::MULTI_STA;
 }
 
 void
@@ -679,7 +679,7 @@
 void
 CtrlBAckResponseHeader::SetBaControl (uint16_t ba)
 {
-  m_baAckPolicy = ((ba & 0x01) == 1) ? true : false;
+  m_baAckPolicy = ((ba & 0x01) == 1);
   if (((ba >> 1) & 0x0f) == 0x03)
     {
       SetType (BlockAckType::MULTI_TID);
@@ -963,7 +963,7 @@
         {
           uint16_t i = IndexInBitmap (seq, index);
           uint8_t mask = uint8_t (0x01) << (i % 8);
-          return ((m_baInfo[index].m_bitmap[i / 8] & mask) != 0) ? true : false;
+          return (m_baInfo[index].m_bitmap[i / 8] & mask) != 0;
         }
       case BlockAckType::MULTI_TID:
         NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
@@ -986,7 +986,7 @@
   switch (m_baType.m_variant)
     {
       case BlockAckType::BASIC:
-        return ((m_baInfo[0].m_bitmap[IndexInBitmap (seq) * 2 + frag / 8] & (0x01 << (frag % 8))) != 0) ? true : false;
+        return (m_baInfo[0].m_bitmap[IndexInBitmap (seq) * 2 + frag / 8] & (0x01 << (frag % 8))) != 0;
       case BlockAckType::COMPRESSED:
       case BlockAckType::EXTENDED_COMPRESSED:
       case BlockAckType::MULTI_STA:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/frame-exchange-manager.cc ns-3.36/src/wifi/model/frame-exchange-manager.cc
--- ns-3.35/src/wifi/model/frame-exchange-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/frame-exchange-manager.cc	2022-04-30 18:23:58.206735100 -0700
@@ -127,7 +127,7 @@
 }
 
 void
-FrameExchangeManager::SetWifiMac (Ptr<RegularWifiMac> mac)
+FrameExchangeManager::SetWifiMac (Ptr<WifiMac> mac)
 {
   NS_LOG_FUNCTION (this << mac);
   m_mac = mac;
@@ -281,7 +281,7 @@
     }
 
   m_dcf->NotifyChannelAccessed ();
-  Ptr<WifiMacQueueItem> mpdu = *queue->Peek ()->GetQueueIterator ();
+  Ptr<WifiMacQueueItem> mpdu = queue->Peek ()->GetItem ();
   NS_ASSERT (mpdu != 0);
   NS_ASSERT (mpdu->GetHeader ().IsData () || mpdu->GetHeader ().IsMgt ());
 
@@ -327,15 +327,12 @@
     {
       NS_LOG_DEBUG ("Fragmenting the MSDU");
       m_fragmentedPacket = mpdu->GetPacket ()->Copy ();
-      AcIndex ac = mpdu->GetQueueAc ();
-      // dequeue the MSDU
-      DequeueMpdu (mpdu);
       // create the first fragment
-      mpdu->GetHeader ().SetMoreFragments ();
       Ptr<Packet> fragment = m_fragmentedPacket->CreateFragment (0, m_mac->GetWifiRemoteStationManager ()->GetFragmentSize (mpdu, 0));
       // enqueue the first fragment
       Ptr<WifiMacQueueItem> item = Create<WifiMacQueueItem> (fragment, mpdu->GetHeader (), mpdu->GetTimeStamp ());
-      m_mac->GetTxopQueue (ac)->PushFront (item);
+      item->GetHeader ().SetMoreFragments ();
+      m_mac->GetTxopQueue (mpdu->GetQueueAc ())->Replace (mpdu, item);
       return item;
     }
   return mpdu;
@@ -388,7 +385,8 @@
 {
   NS_LOG_FUNCTION (this);
 
-  Time txDuration = m_phy->CalculateTxDuration (m_mpdu->GetSize (), m_txParams.m_txVector, m_phy->GetPhyBand ());
+  Time txDuration = m_phy->CalculateTxDuration (GetPsduSize (m_mpdu, m_txParams.m_txVector),
+                                                m_txParams.m_txVector, m_phy->GetPhyBand ());
 
   NS_ASSERT (m_txParams.m_acknowledgment);
 
@@ -405,7 +403,8 @@
     }
   else if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NORMAL_ACK)
     {
-      m_mpdu->GetHeader ().SetDuration (GetFrameDurationId (m_mpdu->GetHeader (), m_mpdu->GetSize (),
+      m_mpdu->GetHeader ().SetDuration (GetFrameDurationId (m_mpdu->GetHeader (),
+                                                            GetPsduSize (m_mpdu, m_txParams.m_txVector),
                                                             m_txParams, m_fragmentedPacket));
 
       // the timeout duration is "aSIFSTime + aSlotTime + aRxPHYStartDelay, starting
@@ -457,6 +456,12 @@
     }
 }
 
+uint32_t
+FrameExchangeManager::GetPsduSize (Ptr<const WifiMacQueueItem> mpdu, const WifiTxVector& txVector) const
+{
+  return mpdu->GetSize ();
+}
+
 void
 FrameExchangeManager::CalculateProtectionTime (WifiProtection* protection) const
 {
@@ -805,29 +810,47 @@
 {
   NS_LOG_FUNCTION (this << *rts << txVector);
 
-  m_mac->GetWifiRemoteStationManager ()->ReportRtsFailed (m_mpdu->GetHeader ());
+  DoCtsTimeout (Create<WifiPsdu> (m_mpdu, true));
+  m_mpdu = nullptr;
+}
+
+void
+FrameExchangeManager::DoCtsTimeout (Ptr<WifiPsdu> psdu)
+{
+  NS_LOG_FUNCTION (this << *psdu);
+
+  m_mac->GetWifiRemoteStationManager ()->ReportRtsFailed (psdu->GetHeader (0));
 
-  if (!m_mac->GetWifiRemoteStationManager ()->NeedRetransmission (m_mpdu))
+  if (!m_mac->GetWifiRemoteStationManager ()->NeedRetransmission (*psdu->begin ()))
     {
-      NS_LOG_DEBUG ("Missed CTS, discard MPDU");
-      // Dequeue the MPDU if it is stored in a queue
-      DequeueMpdu (m_mpdu);
-      NotifyPacketDiscarded (m_mpdu);
-      m_mac->GetWifiRemoteStationManager ()->ReportFinalRtsFailed (m_mpdu->GetHeader ());
+      NS_LOG_DEBUG ("Missed CTS, discard MPDU(s)");
+      m_mac->GetWifiRemoteStationManager ()->ReportFinalRtsFailed (psdu->GetHeader (0));
+      for (const auto& mpdu : *PeekPointer (psdu))
+        {
+          // Dequeue the MPDU if it is stored in a queue
+          DequeueMpdu (mpdu);
+          NotifyPacketDiscarded (mpdu);
+        }
       m_dcf->ResetCw ();
     }
   else
     {
-      NS_LOG_DEBUG ("Missed CTS, retransmit RTS");
-      RetransmitMpduAfterMissedCts (m_mpdu);
+      NS_LOG_DEBUG ("Missed CTS, retransmit MPDU(s)");
       m_dcf->UpdateFailedCw ();
     }
-  m_mpdu = 0;
+  // Make the sequence numbers of the MPDUs available again if the MPDUs have never
+  // been transmitted, both in case the MPDUs have been discarded and in case the
+  // MPDUs have to be transmitted (because a new sequence number is assigned to
+  // MPDUs that have never been transmitted and are selected for transmission)
+  for (const auto& mpdu : *PeekPointer (psdu))
+    {
+      ReleaseSequenceNumber (mpdu);
+    }
   TransmissionFailed ();
 }
 
 void
-FrameExchangeManager::RetransmitMpduAfterMissedCts (Ptr<WifiMacQueueItem> mpdu) const
+FrameExchangeManager::ReleaseSequenceNumber (Ptr<WifiMacQueueItem> mpdu) const
 {
   NS_LOG_FUNCTION (this << *mpdu);
 
@@ -859,7 +882,11 @@
 
   if (mpdu != nullptr)
     {
-      m_mac->GetWifiRemoteStationManager ()->ReportDataFailed (mpdu);
+      if (mpdu->GetHeader ().HasData ()
+          && !mpdu->GetHeader ().GetAddr1 ().IsGroup ())
+        {
+          m_mac->GetWifiRemoteStationManager ()->ReportDataFailed (mpdu);
+        }
 
       if (!mpdu->GetHeader ().GetAddr1 ().IsGroup ()
           && !m_mac->GetWifiRemoteStationManager ()->NeedRetransmission (mpdu))
@@ -884,8 +911,15 @@
 FrameExchangeManager::NotifySwitchingStartNow (Time duration)
 {
   NS_LOG_DEBUG ("Switching channel. Cancelling MAC pending events");
-  m_mac->GetWifiRemoteStationManager ()->Reset ();
-  Reset ();
+  m_mac->NotifyChannelSwitching ();
+  if (m_txTimer.IsRunning ())
+    {
+      // we were transmitting something before channel switching. Since we will
+      // not be able to receive the response, have the timer expire now, so that
+      // we perform the actions required in case of missing response
+      m_txTimer.Reschedule (Seconds (0));
+    }
+  Simulator::ScheduleNow (&FrameExchangeManager::Reset, this);
 }
 
 void
@@ -1142,16 +1176,17 @@
   // a frame containing all or part of an MSDU or MMPDU (sec. 10.3.3 of 802.11-2016)
   m_dcf->ResetCw ();
 
-  // The MPDU has been acknowledged, we can now dequeue it if it is stored in a queue
-  DequeueMpdu (mpdu);
-
   if (mpdu->GetHeader ().IsMoreFragments ())
     {
-      // enqueue the next fragment
-      Ptr<WifiMacQueueItem> next = GetNextFragment ();
-      m_dcf->GetWifiMacQueue ()->PushFront (next);
+      // replace the current fragment with the next one
+      m_dcf->GetWifiMacQueue ()->Replace (mpdu, GetNextFragment ());
       m_moreFragments = true;
     }
+  else
+    {
+      // the MPDU has been acknowledged, we can now dequeue it if it is stored in a queue
+      DequeueMpdu (mpdu);
+    }
 
   TransmissionSucceeded ();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/frame-exchange-manager.h ns-3.36/src/wifi/model/frame-exchange-manager.h
--- ns-3.35/src/wifi/model/frame-exchange-manager.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/frame-exchange-manager.h	2022-04-30 18:23:58.206735100 -0700
@@ -25,7 +25,7 @@
 #include "qos-txop.h"
 #include "wifi-tx-vector.h"
 #include "wifi-psdu.h"
-#include "regular-wifi-mac.h"
+#include "wifi-mac.h"
 #include "mac-rx-middle.h"
 #include "mac-tx-middle.h"
 #include "wifi-phy.h"
@@ -96,7 +96,7 @@
    *
    * \param mac the MAC layer to use
    */
-  virtual void SetWifiMac (const Ptr<RegularWifiMac> mac);
+  virtual void SetWifiMac (const Ptr<WifiMac> mac);
   /**
    * Set the MAC TX Middle to use.
    *
@@ -226,7 +226,7 @@
    * the MAC layer that a channel switching occurred. When a channel switching
    * occurs, pending MAC transmissions (RTS, CTS, Data and Ack) are cancelled.
    */
-  void NotifySwitchingStartNow (Time duration);
+  virtual void NotifySwitchingStartNow (Time duration);
 
   /**
    * This method is typically invoked by the PhyListener to notify
@@ -329,11 +329,12 @@
   virtual void RetransmitMpduAfterMissedAck (Ptr<WifiMacQueueItem> mpdu) const;
 
   /**
-   * Retransmit an MPDU that was not sent because a CTS was not received.
+   * Make the sequence number of the given MPDU available again if the MPDU has
+   * never been transmitted.
    *
-   * \param mpdu the MPDU to retransmit
+   * \param mpdu the given MPDU
    */
-  virtual void RetransmitMpduAfterMissedCts (Ptr<WifiMacQueueItem> mpdu) const;
+  virtual void ReleaseSequenceNumber (Ptr<WifiMacQueueItem> mpdu) const;
 
   /**
    * Pass the given MPDU, discarded because of the max retry limit was reached,
@@ -375,10 +376,21 @@
    */
   void UpdateTxDuration (Mac48Address receiver, WifiTxParameters& txParams) const;
 
+  /**
+   * Get the size in bytes of the given MPDU, which is to be transmitted with the
+   * given TXVECTOR. The purpose of this method is that it can be overridden to
+   * compute the size of an S-MPDU.
+   *
+   * \param mpdu the given MPDU
+   * \param txVector the given TXVECTOR
+   * \return the size of the MPDU
+   */
+  virtual uint32_t GetPsduSize (Ptr<const WifiMacQueueItem> mpdu, const WifiTxVector& txVector) const;
+
   Ptr<Txop> m_dcf;                                  //!< the DCF/EDCAF that gained channel access
   WifiTxTimer m_txTimer;                            //!< the timer set upon frame transmission
   EventId m_navResetEvent;                          //!< the event to reset the NAV after an RTS
-  Ptr<RegularWifiMac> m_mac;                        //!< the MAC layer on this station
+  Ptr<WifiMac> m_mac;                               //!< the MAC layer on this station
   Ptr<MacTxMiddle> m_txMiddle;                      //!< the MAC TX Middle on this station
   Ptr<MacRxMiddle> m_rxMiddle;                      //!< the MAC RX Middle on this station
   Ptr<ChannelAccessManager> m_channelAccessManager; //!< the channel access manager
@@ -510,7 +522,7 @@
    * \param mpdu the MPDU that solicited a Normal Ack response
    * \param txVector the TXVECTOR used to transmit the frame soliciting the Normal Ack
    */
-  void NormalAckTimeout (Ptr<WifiMacQueueItem> mpdu, const WifiTxVector& txVector);
+  virtual void NormalAckTimeout (Ptr<WifiMacQueueItem> mpdu, const WifiTxVector& txVector);
 
   /**
    * Called when the CTS timeout expires.
@@ -519,6 +531,13 @@
    * \param txVector the TXVECTOR used to transmit the RTS frame
    */
   virtual void CtsTimeout (Ptr<WifiMacQueueItem> rts, const WifiTxVector& txVector);
+  /**
+   * Take required actions when the CTS timer fired after sending an RTS to
+   * protect the given PSDU expires.
+   *
+   * \param psdu the PSDU protected by the failed RTS
+   */
+  void DoCtsTimeout (Ptr<WifiPsdu> psdu);
 
 private:
   /**
